## modules 4.1.0

=== Makefile ===
.PHONY: doc pkgdoc initdir install install-testsiteconfig install-testmodulerc \
	install-testetcrc install-testmodspath install-testmodspath-empty \
	uninstall-testconfig uninstall dist dist-tar dist-gzip dist-bzip2 srpm \
	clean distclean test testinstall instrument testcoverage

# definitions for code coverage
NAGELFAR_RELEASE := nagelfar125
NAGELFAR := $(NAGELFAR_RELEASE)/nagelfar.tcl
COVERAGE_SRCFILE := modulecmd.tcl
COVERAGE_IFILE := $(COVERAGE_SRCFILE:.tcl=.tcl_i)
COVERAGE_LOGFILE := $(COVERAGE_SRCFILE:.tcl=.tcl_log)
COVERAGE_MFILE := $(COVERAGE_SRCFILE:.tcl=.tcl_m)

# compatibility version-related files
COMPAT_DIR := compat

# source definitions shared across the Makefiles of this project
ifneq ($(wildcard Makefile.inc),Makefile.inc)
  $(error Makefile.inc is missing, please run './configure')
endif
include Makefile.inc

all: initdir pkgdoc modulecmd.tcl ChangeLog README \
	contrib/scripts/add.modules contrib/scripts/modulecmd
ifeq ($(compatversion),y)
all: $(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog
else
endif

initdir: version.inc
	make -C init all

pkgdoc: version.inc
	make -C doc man txt

doc: version.inc
	make -C doc all

# build version.inc shared definitions from git repository info
ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
GIT_CURRENT_TAG := $(shell git describe --tags --abbrev=0)
GIT_CURRENT_DESC := $(shell git describe --tags)
GIT_CURRENT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD)

MODULES_RELEASE := $(subst v,,$(GIT_CURRENT_TAG))
MODULES_BUILD_DATE := $(shell git log -1 --format=%cd --date=short)
ifeq ($(GIT_CURRENT_TAG),$(GIT_CURRENT_DESC))
MODULES_BUILD :=
else ifeq ($(GIT_CURRENT_BRANCH),master)
MODULES_BUILD := +$(subst $(GIT_CURRENT_TAG)-,,$(GIT_CURRENT_DESC))
else
MODULES_BUILD := +$(GIT_CURRENT_BRANCH)$(subst $(GIT_CURRENT_TAG),,$(GIT_CURRENT_DESC))
endif

# determine RPM release
# retrieve all parts of the release number and increase minor release number
MODULES_RELEASE_BASE := $(firstword $(subst -, ,$(MODULES_RELEASE)))
ifeq ($(MODULES_RELEASE),$(MODULES_RELEASE_BASE))
MODULES_RELEASE_SUFFIX :=
else
MODULES_RELEASE_SUFFIX := $(subst $(MODULES_RELEASE_BASE)-,,$(MODULES_RELEASE))
endif
MODULES_LAST_RPM_VERSREL := $(shell grep -Pzo -m 1 '%changelog\n+\*.* - \K.*\n' \
	contrib/rpm/environment-modules.spec.in)

MODULES_LAST_RPM_RELEASE := $(subst $(MODULES_RELEASE_BASE)-,,$(MODULES_LAST_RPM_VERSREL))
ifneq ($(MODULES_RELEASE_SUFFIX),)
MODULES_LAST_RPM_RELEASE := $(subst .$(MODULES_RELEASE_SUFFIX),,$(MODULES_LAST_RPM_RELEASE))
endif

# use last release if we currently sat on tag
ifeq ($(GIT_CURRENT_TAG),$(GIT_CURRENT_DESC))
MODULES_RPM_RELEASE := $(MODULES_LAST_RPM_RELEASE)
else
MODULES_LAST_RPM_RELEASE_P1 := $(firstword $(subst ., ,$(MODULES_LAST_RPM_RELEASE)))
MODULES_LAST_RPM_RELEASE_P2 := $(subst $(MODULES_LAST_RPM_RELEASE_P1).,,$(MODULES_LAST_RPM_RELEASE))

ifeq ($(MODULES_LAST_RPM_RELEASE_P2),)
MODULES_RPM_RELEASE_P2 := 1
else
MODULES_RPM_RELEASE_P2 := $(shell echo $$(($(MODULES_LAST_RPM_RELEASE_P2)+1)))
endif

MODULES_RPM_RELEASE := $(MODULES_LAST_RPM_RELEASE_P1).$(MODULES_RPM_RELEASE_P2)
ifneq ($(MODULES_RELEASE_SUFFIX),)
MODULES_RPM_RELEASE := $(MODULES_RPM_RELEASE).$(MODULES_RELEASE_SUFFIX)
endif
MODULES_RPM_RELEASE := $(MODULES_RPM_RELEASE)$(subst -,.,$(MODULES_BUILD))
endif

else
# source version definitions shared across the Makefiles of this project
ifneq ($(wildcard version.inc),version.inc)
  $(error version.inc is missing)
endif
include version.inc
endif

# comment entries if feature not enabled
ifeq ($(versioning),y)
  setversioning :=
  setnotversioning := \#
else
  setversioning := \#
  setnotversioning :=
endif

define translate-in-script
sed -e 's|@prefix@|$(prefix)|g' \
	-e 's|@baseprefix@|$(baseprefix)|g' \
	-e 's|@libexecdir@|$(libexecdir)|g' \
	-e 's|@initdir@|$(initdir)|g' \
	-e 's|@etcdir@|$(etcdir)|g' \
	-e 's|@modulefilesdir@|$(modulefilesdir)|g' \
	-e 's|@VERSION@|$(VERSION)|g' \
	-e 's|@TCLSHDIR@/tclsh|$(TCLSH)|g' \
	-e 's|@TCLSH@|$(TCLSH)|g' \
	-e 's|@pager@|$(pager)|g' \
	-e 's|@pageropts@|$(pageropts)|g' \
	-e 's|@VERSIONING@|$(setversioning)|g' \
	-e 's|@NOTVERSIONING@|$(setnotversioning)|g' \
	-e 's|@MODULES_RELEASE@|$(MODULES_RELEASE)|g' \
	-e 's|@MODULES_BUILD@|$(MODULES_BUILD)|g' \
	-e 's|@MODULES_RPM_RELEASE@|$(MODULES_RPM_RELEASE)|g' \
	-e 's|@MODULES_BUILD_DATE@|$(MODULES_BUILD_DATE)|g' $< > $@
endef

ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
# rebuild if git repository changed
version.inc: version.inc.in .git/index
	$(translate-in-script)

contrib/rpm/environment-modules.spec: contrib/rpm/environment-modules.spec.in .git/index
	$(translate-in-script)

else
# avoid shared definitions to be rebuilt by make
version.inc: ;

# do not rebuild spec file if not in git repository
contrib/rpm/environment-modules.spec: ;
endif

DIST_PREFIX := modules-$(MODULES_RELEASE)$(MODULES_BUILD)

# avoid shared definitions to be rebuilt by make
Makefile.inc: ;

modulecmd.tcl: modulecmd.tcl.in version.inc
	$(translate-in-script)
	chmod +x $@

ChangeLog:
	contrib/gitlog2changelog.py

README:
	sed -e '/^\[\!\[.*\].*/d' $@.md > $@

contrib/scripts/add.modules: contrib/scripts/add.modules.in
	$(translate-in-script)

contrib/scripts/modulecmd: contrib/scripts/modulecmd.in
	$(translate-in-script)

# compatibility version-related rules
$(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog:
	make -C $(COMPAT_DIR) $(@F)

# example configs for test rules
testsuite/example/.modulespath: testsuite/example/.modulespath.in
	$(translate-in-script)

testsuite/example/modulerc: testsuite/example/modulerc.in
	$(translate-in-script)

install-testsiteconfig: testsuite/example/siteconfig.tcl
	make -C init install-testconfig DESTDIR=$(DESTDIR)
	cp $^ $(DESTDIR)$(etcdir)/

install-testmodulerc: testsuite/example/modulerc
	make -C init install-testconfig DESTDIR=$(DESTDIR)
	cp $^ $(DESTDIR)$(initdir)/

install-testetcrc: testsuite/etc/empty
	make -C init install-testconfig DESTDIR=$(DESTDIR)
	cp $^ $(DESTDIR)$(prefix)/etc/rc

install-testmodspath: testsuite/example/.modulespath
	make -C init install-testconfig DESTDIR=$(DESTDIR)
	cp $^ $(DESTDIR)$(initdir)/

install-testmodspath-empty: testsuite/example/.modulespath-empty
	make -C init install-testconfig DESTDIR=$(DESTDIR)
	cp $^ $(DESTDIR)$(initdir)/.modulespath

uninstall-testconfig:
	rm -f $(DESTDIR)$(prefix)/etc/rc
	rm -f $(DESTDIR)$(etcdir)/siteconfig.tcl
	rm -f $(DESTDIR)$(initdir)/modulerc
	rm -f $(DESTDIR)$(initdir)/.modulespath
	make -C init uninstall-testconfig DESTDIR=$(DESTDIR)

ifeq ($(compatversion),y)
install: modulecmd.tcl ChangeLog README contrib/scripts/add.modules \
	contrib/scripts/modulecmd $(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog
else
install: modulecmd.tcl ChangeLog README contrib/scripts/add.modules \
	contrib/scripts/modulecmd
endif
	mkdir -p $(DESTDIR)$(libexecdir)
	mkdir -p $(DESTDIR)$(bindir)
	cp modulecmd.tcl $(DESTDIR)$(libexecdir)/
	chmod +x $(DESTDIR)$(libexecdir)/modulecmd.tcl
ifeq ($(compatversion),y)
	cp $(COMPAT_DIR)/modulecmd $(DESTDIR)$(libexecdir)/modulecmd-compat
	chmod +x $(DESTDIR)$(libexecdir)/modulecmd-compat
endif
	cp contrib/envml $(DESTDIR)$(bindir)/
	chmod +x $(DESTDIR)$(bindir)/envml
	cp contrib/scripts/add.modules $(DESTDIR)$(bindir)/
	chmod +x $(DESTDIR)$(bindir)/add.modules
	cp contrib/scripts/modulecmd $(DESTDIR)$(bindir)/
	chmod +x $(DESTDIR)$(bindir)/modulecmd
	cp contrib/scripts/mkroot $(DESTDIR)$(bindir)/
	chmod +x $(DESTDIR)$(bindir)/mkroot
ifeq ($(docinstall),y)
	mkdir -p $(DESTDIR)$(docdir)
	cp COPYING.GPLv2 $(DESTDIR)$(docdir)/
	cp ChangeLog $(DESTDIR)$(docdir)/
	cp README $(DESTDIR)$(docdir)/
ifeq ($(compatversion),y)
	cp $(COMPAT_DIR)/ChangeLog $(DESTDIR)$(docdir)/ChangeLog-compat
	cp $(COMPAT_DIR)/NEWS $(DESTDIR)$(docdir)/NEWS-compat
endif
endif
	make -C init install DESTDIR=$(DESTDIR)
	make -C doc install DESTDIR=$(DESTDIR)
	@echo
	@echo "NOTICE: Modules installation is complete."
	@echo "        Please read the 'Configuration' section in INSTALL.txt to learn"
	@echo "        how to adapt your installation and make it fit your needs." >&2
	@echo

uninstall:
	rm -f $(DESTDIR)$(libexecdir)/modulecmd.tcl
ifeq ($(compatversion),y)
	rm -f $(DESTDIR)$(libexecdir)/modulecmd-compat
endif
	rm -f $(DESTDIR)$(bindir)/envml
	rm -f $(DESTDIR)$(bindir)/add.modules
	rm -f $(DESTDIR)$(bindir)/modulecmd
	rm -f $(DESTDIR)$(bindir)/mkroot
ifeq ($(docinstall),y)
	rm -f $(addprefix $(DESTDIR)$(docdir)/,ChangeLog README COPYING.GPLv2)
ifeq ($(compatversion),y)
	rm -f $(addprefix $(DESTDIR)$(docdir)/,ChangeLog-compat NEWS-compat)
endif
endif
	make -C init uninstall DESTDIR=$(DESTDIR)
	make -C doc uninstall DESTDIR=$(DESTDIR)
	rmdir $(DESTDIR)$(libexecdir)
	rmdir $(DESTDIR)$(bindir)
	rmdir $(DESTDIR)$(datarootdir)
	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(prefix)

# include pre-generated documents not to require documentation build
# tools when installing from dist tarball
dist-tar: ChangeLog README version.inc contrib/rpm/environment-modules.spec pkgdoc
	git archive --prefix=$(DIST_PREFIX)/ --worktree-attributes \
		-o $(DIST_PREFIX).tar HEAD
	cp doc/build/MIGRATING.txt  doc/build/INSTALL.txt doc/build/NEWS.txt ./
	tar -rf $(DIST_PREFIX).tar --transform 's,^,$(DIST_PREFIX)/,' \
		ChangeLog README MIGRATING.txt INSTALL.txt NEWS.txt version.inc \
		doc/build/MIGRATING.txt doc/build/diff_v3_v4.txt \
		doc/build/INSTALL.txt doc/build/NEWS.txt \
		doc/build/module.1.in doc/build/modulefile.4 \
		contrib/rpm/environment-modules.spec
ifeq ($(compatversion) $(wildcard $(COMPAT_DIR)),y $(COMPAT_DIR))
	make -C $(COMPAT_DIR) distdir
	mv $(COMPAT_DIR)/modules-* compatdist
	tar -cf compatdist.tar --transform 's,^compatdist,$(DIST_PREFIX)/compat,' compatdist
	tar --concatenate -f $(DIST_PREFIX).tar compatdist.tar
	rm -rf compatdist
	rm compatdist.tar
endif

dist-gzip: dist-tar
	gzip -f -9 $(DIST_PREFIX).tar

dist-bzip2: dist-tar
	bzip2 -f $(DIST_PREFIX).tar

dist: dist-gzip

srpm: dist-bzip2
	rpmbuild -ts $(DIST_PREFIX).tar.bz2

clean:
	rm -f *.log *.sum
	rm -f $(COVERAGE_IFILE) $(COVERAGE_LOGFILE) $(COVERAGE_MFILE)
	rm -rf coverage
ifeq ($(wildcard .git) $(wildcard contrib/gitlog2changelog.py),.git contrib/gitlog2changelog.py)
	rm -f ChangeLog
endif
ifeq ($(wildcard .git) $(wildcard README.md),.git README.md)
	rm -f README
endif
ifeq ($(wildcard .git) $(wildcard MIGRATING.rst),.git MIGRATING.rst)
	rm -f MIGRATING.txt
endif
ifeq ($(wildcard .git) $(wildcard INSTALL.rst),.git INSTALL.rst)
	rm -f INSTALL.txt
endif
ifeq ($(wildcard .git) $(wildcard NEWS.rst),.git NEWS.rst)
	rm -f NEWS.txt
endif
	rm -f modulecmd.tcl
	rm -f contrib/scripts/add.modules
	rm -f contrib/scripts/modulecmd
	rm -f testsuite/example/.modulespath testsuite/example/modulerc
	rm -f modules-*.tar modules-*.tar.gz modules-*.tar.bz2
	rm -f modules-*.srpm
	make -C init clean
	make -C doc clean
ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
	rm -f version.inc
	rm -f contrib/rpm/environment-modules.spec
endif
ifneq ($(wildcard $(COMPAT_DIR)/Makefile),)
	make -C compat clean
endif

distclean: clean
	rm -f Makefile.inc
	rm -f site.exp
	rm -rf $(NAGELFAR_RELEASE)
ifeq ($(wildcard .git) $(wildcard $(COMPAT_DIR)),.git $(COMPAT_DIR))
	rm -rf $(COMPAT_DIR)
	git worktree prune
endif

ifeq ($(compatversion) $(wildcard $(COMPAT_DIR)),y $(COMPAT_DIR))
test: modulecmd.tcl $(COMPAT_DIR)/modulecmd
	make -C $(COMPAT_DIR) test
else
test: modulecmd.tcl
endif
	TCLSH=$(TCLSH); export TCLSH; \
	OBJDIR=`pwd -P`; export OBJDIR; \
	TESTSUITEDIR=`cd testsuite;pwd -P`; export TESTSUITEDIR; \
	runtest --srcdir $$TESTSUITEDIR --objdir $$OBJDIR $(RUNTESTFLAGS) --tool modules

testinstall:
	OBJDIR=`pwd -P`; export OBJDIR; \
	TESTSUITEDIR=`cd testsuite;pwd -P`; export TESTSUITEDIR; \
	runtest --srcdir $$TESTSUITEDIR --objdir $$OBJDIR $(RUNTESTFLAGS) --tool install


# install code coverage tool
$(NAGELFAR):
	wget http://downloads.sourceforge.net/nagelfar/$(NAGELFAR_RELEASE).tar.gz
	tar xzf $(NAGELFAR_RELEASE).tar.gz

=== doc/Makefile ===
.PHONY: install uninstall clean

SOURCE_DIR := source
BUILD_DIR := build

SPHINXOPTS := -q

# compatibility version-related files
COMPAT_MAN_DIR := ../compat/doc

# source definitions shared across the Makefiles of this project
ifneq ($(wildcard ../Makefile.inc),../Makefile.inc)
  $(error ../Makefile.inc is missing, please run '../configure')
endif
include ../Makefile.inc

# source version definitions shared across the Makefiles of this project
include ../version.inc

man: $(BUILD_DIR)/module.1 $(BUILD_DIR)/modulefile.4
ifeq ($(compatversion),y)
man: $(COMPAT_MAN_DIR)/module.1 $(COMPAT_MAN_DIR)/modulefile.4
endif

txt: $(BUILD_DIR)/diff_v3_v4.txt $(BUILD_DIR)/MIGRATING.txt \
	$(BUILD_DIR)/INSTALL.txt $(BUILD_DIR)/NEWS.txt

html: $(BUILD_DIR)/module.html $(BUILD_DIR)/modulefile.html \
	$(BUILD_DIR)/diff_v3_v4.html $(BUILD_DIR)/MIGRATING.html \
	$(BUILD_DIR)/INSTALL.html $(BUILD_DIR)/NEWS.html

all: man txt

# enable HTML pages build only from git repository
ifeq ($(wildcard ../.git),../.git)
all: html
endif

define translate-in-script
sed -e 's|@prefix@|$(prefix)|g' \
	-e 's|@libexecdir@|$(libexecdir)|g' \
	-e 's|@etcdir@|$(etcdir)|g' \
	-e 's|@initdir@|$(initdir)|g' \
	-e 's|@modulefilesdir@|$(modulefilesdir)|g' \
	-e 's|@MODULES_RELEASE@|$(MODULES_RELEASE)|g' \
	-e 's|@MODULES_BUILD@|$(MODULES_BUILD)|g' \
	-e 's|@MODULES_BUILD_DATE@|$(MODULES_BUILD_DATE)|g' $< > $@
endef

# avoid shared definitions to be rebuilt by make
../Makefile.inc ../version.inc: ;

# build doc from source if in git repository
ifeq ($(wildcard ../.git),../.git)
$(SOURCE_DIR)/version.py: $(SOURCE_DIR)/version.py.in ../version.inc
	$(translate-in-script)

$(BUILD_DIR)/%.html: $(SOURCE_DIR)/%.rst $(SOURCE_DIR)/version.py
	$(SPHINXBUILD) $(SPHINXOPTS) -b html "$(SOURCE_DIR)" "$(BUILD_DIR)"

$(BUILD_DIR)/%.txt: $(SOURCE_DIR)/%.rst $(SOURCE_DIR)/version.py
	$(SPHINXBUILD) $(SPHINXOPTS) -b text "$(SOURCE_DIR)" "$(BUILD_DIR)"

$(BUILD_DIR)/%.4: $(SOURCE_DIR)/%.rst $(SOURCE_DIR)/version.py
	$(SPHINXBUILD) $(SPHINXOPTS) -t pathsubs -b man "$(SOURCE_DIR)" "$(BUILD_DIR)"

$(BUILD_DIR)/%.1.in: $(SOURCE_DIR)/%.rst $(SOURCE_DIR)/version.py
	$(SPHINXBUILD) $(SPHINXOPTS) -t pathsubs -b man "$(SOURCE_DIR)" "$(BUILD_DIR)"
	mv $(BUILD_DIR)/module.1 $@
endif

$(BUILD_DIR)/module.1: $(BUILD_DIR)/module.1.in
	$(translate-in-script)

# compatibility version-related rules
$(COMPAT_MAN_DIR)/module.1 $(COMPAT_MAN_DIR)/modulefile.4:
	make -C $(COMPAT_MAN_DIR) $(@F)

install: man txt
	mkdir -p $(DESTDIR)$(mandir)/man1 $(DESTDIR)$(mandir)/man4
ifeq ($(docinstall),y)
	mkdir -p $(DESTDIR)$(docdir)
	cp $(BUILD_DIR)/diff_v3_v4.txt $(DESTDIR)$(docdir)/
	cp $(BUILD_DIR)/MIGRATING.txt $(DESTDIR)$(docdir)/
	cp $(BUILD_DIR)/INSTALL.txt $(DESTDIR)$(docdir)/
	cp $(BUILD_DIR)/NEWS.txt $(DESTDIR)$(docdir)/
	cp example.txt $(DESTDIR)$(docdir)/
endif
	cp $(BUILD_DIR)/module.1 $(DESTDIR)$(mandir)/man1/
	cp $(BUILD_DIR)/modulefile.4 $(DESTDIR)$(mandir)/man4/
ifeq ($(compatversion),y)
	cp $(COMPAT_MAN_DIR)/module.1 $(DESTDIR)$(mandir)/man1/module-compat.1
	cp $(COMPAT_MAN_DIR)/modulefile.4 $(DESTDIR)$(mandir)/man4/modulefile-compat.4
endif

uninstall:
ifeq ($(docinstall),y)
	rm -f $(DESTDIR)$(docdir)/diff_v3_v4.txt
	rm -f $(DESTDIR)$(docdir)/MIGRATING.txt
	rm -f $(DESTDIR)$(docdir)/INSTALL.txt
	rm -f $(DESTDIR)$(docdir)/NEWS.txt
	rm -f $(DESTDIR)$(docdir)/example.txt
	rmdir $(DESTDIR)$(docdir)
endif
	rm -f $(DESTDIR)$(mandir)/man1/module.1
	rm -f $(DESTDIR)$(mandir)/man4/modulefile.4
ifeq ($(compatversion),y)
	rm -f $(DESTDIR)$(mandir)/man1/module-compat.1
	rm -f $(DESTDIR)$(mandir)/man4/modulefile-compat.4
endif
	rmdir $(DESTDIR)$(mandir)/man1 $(DESTDIR)$(mandir)/man4
	rmdir $(DESTDIR)$(mandir)

clean:
# do not clean generated docs if not in git repository
ifeq ($(wildcard ../.git),../.git)
ifeq ($(wildcard $(BUILD_DIR)),$(BUILD_DIR))
	rm -rf $(BUILD_DIR)
endif
	rm -f $(SOURCE_DIR)/version.py
endif
	rm -f $(BUILD_DIR)/*.1

=== init/Makefile ===
.PHONY: install install-testconfig uninstall-testconfig uninstall clean

SH_LIKE  = sh ksh bash zsh profile.sh bash_completion
CSH_LIKE = csh tcsh tcsh_completion profile.csh
OTHER    = perl.pm python.py ruby.rb lisp tcl fish cmake r.R

# example modulefiles to install
EXAMPLE_MODFILES_SRCDIR := ../contrib/modulefiles
EXAMPLE_MODFILES = dot module-git module-info modules null use.own
EXAMPLE_TESTCONFIG_MODFILES = null

# source definitions shared across the Makefiles of this project
ifneq ($(wildcard ../Makefile.inc),../Makefile.inc)
  $(error ../Makefile.inc is missing, please run '../configure')
endif
include ../Makefile.inc

# source version definitions shared across the Makefiles of this project
include ../version.inc

# kind of config file to use: modulerc or .modulespath
ifeq ($(setdotmodulespath),y)
  # both configuration files will be installed and in this case default init
  # scripts will use .modulespath prior to modulerc. If .modulespath sets a
  # module path then modulerc will be ignored
  ALL_CONFIG := .modulespath modulerc
else
  ALL_CONFIG := modulerc
endif

# generate 'module use' commands to put in modulerc from modulepath
modulerc := $(addprefix \nmodule use --append {,$(subst :,} {,$(modulepath)}))
# generate 'module load' commands to put in modulerc from loadedmodules
ifneq ($(loadedmodules),)
  modulerc := $(modulerc)$(addprefix \nmodule load ,\
    $(subst :, ,$(loadedmodules)))
endif

ifeq ($(compatversion),y)
SH_LIKE += profile-compat.sh
CSH_LIKE += profile-compat.csh
endif

ALL_SHELLS = $(SH_LIKE) $(CSH_LIKE) $(OTHER)

all: $(ALL_SHELLS) $(ALL_CONFIG) $(EXAMPLE_MODFILES_SRCDIR)/modules
ifeq ($(versioning),y)
all: $(EXAMPLE_MODFILES_SRCDIR)/version
endif

# if enabled translate to keep text after markup elsewhere remove the
# entire line
ifeq ($(setmanpath),y)
  setmanpathre := s|@setmanpath@||g
else
  setmanpathre := /@setmanpath@/d
endif
ifeq ($(setbinpath),y)
  setbinpathre := s|@setbinpath@||g
else
  setbinpathre := /@setbinpath@/d
endif
ifeq ($(compatversion),y)
  compatversionre := s|@compatversion@||g
  notcompatversionre := /@notcompatversion@/d
else
  compatversionre := /@compatversion@/d
  notcompatversionre := s|@notcompatversion@||g
endif

# comment entries if feature not enabled
ifeq ($(versioning),y)
  versdir := $(baseprefix)/versions
  setversioning :=
else
  setversioning := \#
endif

# define translation rules for quarantine mechanism
ifeq ($(quarantinevars),)
setquarvarsre := /@setquarvars@/d
notsetquarvarsre := s|@notsetquarvars@||g
else
setquarvarsre := s|@setquarvars@||g
notsetquarvarsre := /@notsetquarvars@/d
define runenvvarre
$(if $(filter-out ${1},${2}),s|\(@\(.*\)RUNENV_VAR\(.*\)RUNENV_VAL\(.*\)@\)|\2MODULES_RUNENV_${1}\3${2}\4\n\1|g;)
endef
quarvarsre = -e 's|@RUN_QUARANTINE@|$(foreach vv,$(quarantinevars),$(firstword\
	$(subst =, ,$(vv))))|g;
quarvarsre += $(foreach vv,$(quarantinevars),$(call runenvvarre,$(firstword\
	$(subst =, ,$(vv))),$(subst $(firstword $(subst =, ,$(vv)))=,,$(vv))))
quarvarsre += s/@.*RUNENV_VAR.*@//;'
endif

define translate-in-script
sed -e 's|@prefix@|$(prefix)|g' \
	-e 's|@baseprefix@|$(baseprefix)|g' \
	-e 's|@libexecdir@|$(libexecdir)|g' \
	-e 's|@initdir@|$(initdir)|g' \
	-e 's|@etcdir@|$(etcdir)|g' \
	-e 's|@modulefilesdir@|$(modulefilesdir)|g' \
	-e 's|@bindir@|$(bindir)|g' \
	-e 's|@mandir@|$(mandir)|g' \
	-e '$(setmanpathre)' \
	-e '$(setbinpathre)' \
	-e '$(compatversionre)' \
	-e '$(notcompatversionre)' \
	-e 's|@modulerc@|$(modulerc)|g' \
	-e 's|@modulepath@|$(modulepath)|g' \
	-e '$(setquarvarsre)' $(quarvarsre) \
	-e '$(notsetquarvarsre)' \
	-e 's|@SHELLNAME@|$@|g' \
	-e 's|@VERSIONING@|$(setversioning)|g' \
	-e 's|@VERSION@|$(VERSION)|g' \
	-e 's|@TCLSH@|$(TCLSH)|g' $< > $@
endef

# avoid shared definitions to be rebuilt by make
../Makefile.inc ../version.inc: ;

%: %.in
	$(translate-in-script)

# tcsh is derivated from csh init script
tcsh: csh.in
	$(translate-in-script)

# this rule is needed for profile.sh to get matched
profile.sh: profile.sh.in
	$(translate-in-script)

# this rule is needed for profile-compat.sh to get matched
profile-compat.sh: profile-compat.sh.in
	$(translate-in-script)

$(EXAMPLE_MODFILES_SRCDIR)/modules: $(EXAMPLE_MODFILES_SRCDIR)/modules.in ../version.inc
	$(translate-in-script)

$(EXAMPLE_MODFILES_SRCDIR)/version: $(EXAMPLE_MODFILES_SRCDIR)/version.in ../version.inc
	$(translate-in-script)

# example configs for test rules
install-testconfig:
	mkdir -p $(DESTDIR)$(initdir)
	mkdir -p $(DESTDIR)$(etcdir)
	mkdir -p $(DESTDIR)$(prefix)/etc
	mkdir -p $(DESTDIR)$(modulefilesdir)
	mkdir -p $(DESTDIR)$(prefix)/test/modulefiles $(DESTDIR)$(prefix)/test/etc
	cp $(addprefix $(EXAMPLE_MODFILES_SRCDIR)/,$(EXAMPLE_TESTCONFIG_MODFILES)) $(DESTDIR)$(modulefilesdir)/

uninstall-testconfig:
	rmdir $(DESTDIR)$(prefix)/test/modulefiles $(DESTDIR)$(prefix)/test/etc $(DESTDIR)$(prefix)/test
	rm -f $(addprefix $(DESTDIR)$(modulefilesdir)/,$(EXAMPLE_TESTCONFIG_MODFILES))
	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(modulefilesdir)
	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(etcdir)
	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(initdir)

install: all
	mkdir -p $(DESTDIR)$(initdir)
	mkdir -p $(DESTDIR)$(initdir)/ksh-functions
	mkdir -p $(DESTDIR)$(modulefilesdir)
	cp $(ALL_SHELLS) $(DESTDIR)$(initdir)/
	cp fish_completion $(DESTDIR)$(initdir)/
	cp -r zsh-functions $(DESTDIR)$(initdir)/
	cp ksh $(DESTDIR)$(initdir)/ksh-functions/module
ifeq ($(compatversion),y)
	cp ksh $(DESTDIR)$(initdir)/ksh-functions/switchml
else
	rm -f $(DESTDIR)$(initdir)/ksh-functions/switchml
endif
	cp -P --remove-destination $(ALL_CONFIG) $(DESTDIR)$(initdir)/
ifeq ($(examplemodulefiles),y)
	cp $(addprefix $(EXAMPLE_MODFILES_SRCDIR)/,$(EXAMPLE_MODFILES)) $(DESTDIR)$(modulefilesdir)/
endif
ifeq ($(versioning),y)
	mkdir -p $(DESTDIR)$(versdir)
	cp $(EXAMPLE_MODFILES_SRCDIR)/version $(DESTDIR)$(versdir)/$(VERSION)
endif

uninstall:
	rm -f $(addprefix $(DESTDIR)$(initdir)/,$(ALL_SHELLS) fish_completion)
	rm -f $(DESTDIR)$(initdir)/ksh-functions/module
ifeq ($(compatversion),y)
	rm -f $(DESTDIR)$(initdir)/ksh-functions/switchml
endif
	rm -f $(DESTDIR)$(initdir)/zsh-functions/_module
	rm -f $(addprefix $(DESTDIR)$(initdir)/,$(ALL_CONFIG))
	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(modulefilesdir)
	@if [ -d $(DESTDIR)$(modulefilesdir) ]; then echo -e "\nWARNING: $(DESTDIR)$(modulefilesdir) is not empty so skip removal\n" >&2; fi
	rmdir $(DESTDIR)$(initdir)/ksh-functions
	rmdir $(DESTDIR)$(initdir)/zsh-functions
	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(initdir)
	@if [ -d $(DESTDIR)$(initdir) ]; then echo -e "\nWARNING: $(DESTDIR)$(initdir) is not empty so skip removal\n" >&2; fi
ifeq ($(versioning),y)
	rm -f $(DESTDIR)$(versdir)/$(VERSION)
	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(versdir)
	@if [ -d $(DESTDIR)$(versdir) ]; then echo -e "\nWARNING: $(DESTDIR)$(versdir) is not empty so skip removal\n" >&2; fi
endif

clean:
	rm -f $(ALL_SHELLS) modulerc .modulespath $(EXAMPLE_MODFILES_SRCDIR)/modules
ifeq ($(versioning),y)
	rm -f $(EXAMPLE_MODFILES_SRCDIR)/version
endif

=== debian/changelog ===
modules (4.1.0-1) unstable; urgency=medium

  * New upstream release
  * Fix manual files location to /usr/share/man
  * Standards-Version: 4.1.3
  * Add 'less' as build dependency

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 20 Jan 2018 22:10:21 +0000

modules (4.0.0-2) unstable; urgency=medium

  * Fix symlink for bash completion. Closes: #879613
  * Fix paths.patch for sh that broke sudo , su use. Closes: #883169

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 05 Dec 2017 12:37:11 +0000

=== debian/control ===
Source: modules
Section: devel
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Standards-Version: 4.1.3
Homepage: http://modules.sourceforge.net/
Build-Depends: tcl8.6-dev | tcl-dev, 
  debhelper (>= 10), 
  dejagnu, 
  tclx8.4-dev,
  less

Package: environment-modules
Architecture: any
Depends: debhelper (>= 10), tcl8.6 | tcl, ${misc:Depends}, ${shlibs:Depends}
Conflicts: lmod
Description: Modular system for handling environment variables
 The Modules package provides for the dynamic modification of a user's
 environment via modulefiles.  Each modulefile contains the information
 needed to configure the shell for an application. Once the Modules
 package is initialized, the environment can be modified dynamically
 on a per-module basis using the module command which interprets
 modulefiles. Typically modulefiles instruct the module command to alter or
 set shell environment variables such as PATH, MANPATH, etc. modulefiles
 may be shared by many users on a system and users may have their own
 collection to supplement or replace the shared modulefiles.  The modules
 environment is common on SGI/Crays and many workstation farms.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

TDIR=debian/environment-modules
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

DEB_BUILD_MAINT_OPTIONS:=hardening=+all
DEB_CFLAGS_MAINT_APPEND:= -Wall -pedantic
DEB_LDFLAGS_MAINT_APPEND:= -Wl,--as-needed
export  DEB_BUILD_MAINT_OPTIONS DEB_CFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_APPEND

# The magic debhelper  rule
%:
	dh $@ 

override_dh_auto_clean:
	$(MAKE) clean || echo "Make clean skipped"
	rm -f stamp-h

override_dh_auto_configure:
	dh_auto_configure -- \
                --prefix=/usr  --with-version-path=/usr/share/modules/versions \
		--with-module-path=/usr/share/modules/modulefiles \
		--with-tcl-ver=8.6 \
		--enable-logging \
		--bindir=/usr/bin #LDFLAGS='$(LDFLAGS) -Wl,--as-needed' CFLAGS='$(CFLAGS) '

override_dh_auto_test:
	@echo "Tests currently disabled - csh based test failing"

override_dh_auto_install:
	dh_auto_install
	# Fix brain-dead install locations.
	mv $(TDIR)/usr/modulefiles $(TDIR)/usr/share/modules
	mkdir -p $(TDIR)/usr/share/environment-modules
	mv $(TDIR)/usr/share/doc/* $(TDIR)/usr/share/environment-modules
	mv $(TDIR)/usr/share/environment-modules $(TDIR)/usr/share/doc
	mv $(TDIR)/usr/init $(TDIR)/usr/share/modules/init
	mv $(TDIR)/share/man $(TDIR)/usr/share/man
	mv $(TDIR)/lib $(TDIR)/usr
	rmdir $(TDIR)/share
	rm $(TDIR)/usr/share/doc/environment-modules/COPYING.GPLv2* $(TDIR)/usr/share/doc/environment-modules/INSTALL.txt*
	rm $(TDIR)/usr/share/doc/environment-modules/ChangeLog
	cp debian/profile.sh $(TDIR)/etc/profile.d/modules.sh
	dh_link /etc/environment-modules/modulespath /usr/share/modules/init/.modulespath 
	dh_link $(LIBDIR)/modulecmd.tcl /usr/lib/modulecmd.tcl
	dh_link /usr/share/modules/init/bash_completion /usr/share/bash-completion/completions/modules

## modules 4.1.1

=== Makefile ===
--- 
+++ 
@@ -20,21 +20,25 @@
 endif
 include Makefile.inc
 
-all: initdir pkgdoc modulecmd.tcl ChangeLog README \
+all: initdir modulecmd.tcl ChangeLog README \
 	contrib/scripts/add.modules contrib/scripts/modulecmd
 ifeq ($(compatversion),y)
 all: $(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog
 else
 endif
+# skip doc build if no sphinx-build
+ifeq ($(builddoc),y)
+all: pkgdoc
+endif
 
 initdir: version.inc
-	make -C init all
+	$(MAKE) -C init all
 
 pkgdoc: version.inc
-	make -C doc man txt
+	$(MAKE) -C doc man txt
 
 doc: version.inc
-	make -C doc all
+	$(MAKE) -C doc all
 
 # build version.inc shared definitions from git repository info
 ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
@@ -60,7 +64,7 @@
 else
 MODULES_RELEASE_SUFFIX := $(subst $(MODULES_RELEASE_BASE)-,,$(MODULES_RELEASE))
 endif
-MODULES_LAST_RPM_VERSREL := $(shell grep -Pzo -m 1 '%changelog\n+\*.* - \K.*\n' \
+MODULES_LAST_RPM_VERSREL := $(shell $(GREP) -Pzo -m 1 '%changelog\n+\*.* - \K.*\n' \
 	contrib/rpm/environment-modules.spec.in)
 
 MODULES_LAST_RPM_RELEASE := $(subst $(MODULES_RELEASE_BASE)-,,$(MODULES_LAST_RPM_VERSREL))
@@ -164,7 +168,7 @@
 
 # compatibility version-related rules
 $(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog:
-	make -C $(COMPAT_DIR) $(@F)
+	$(MAKE) -C $(COMPAT_DIR) $(@F)
 
 # example configs for test rules
 testsuite/example/.modulespath: testsuite/example/.modulespath.in
@@ -174,23 +178,23 @@
 	$(translate-in-script)
 
 install-testsiteconfig: testsuite/example/siteconfig.tcl
-	make -C init install-testconfig DESTDIR=$(DESTDIR)
+	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(etcdir)/
 
 install-testmodulerc: testsuite/example/modulerc
-	make -C init install-testconfig DESTDIR=$(DESTDIR)
+	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(initdir)/
 
 install-testetcrc: testsuite/etc/empty
-	make -C init install-testconfig DESTDIR=$(DESTDIR)
+	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(prefix)/etc/rc
 
 install-testmodspath: testsuite/example/.modulespath
-	make -C init install-testconfig DESTDIR=$(DESTDIR)
+	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(initdir)/
 
 install-testmodspath-empty: testsuite/example/.modulespath-empty
-	make -C init install-testconfig DESTDIR=$(DESTDIR)
+	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(initdir)/.modulespath
 
 uninstall-testconfig:
@@ -198,7 +202,7 @@
 	rm -f $(DESTDIR)$(etcdir)/siteconfig.tcl
 	rm -f $(DESTDIR)$(initdir)/modulerc
 	rm -f $(DESTDIR)$(initdir)/.modulespath
-	make -C init uninstall-testconfig DESTDIR=$(DESTDIR)
+	$(MAKE) -C init uninstall-testconfig DESTDIR=$(DESTDIR)
 
 ifeq ($(compatversion),y)
 install: modulecmd.tcl ChangeLog README contrib/scripts/add.modules \
@@ -233,8 +237,13 @@
 	cp $(COMPAT_DIR)/NEWS $(DESTDIR)$(docdir)/NEWS-compat
 endif
 endif
-	make -C init install DESTDIR=$(DESTDIR)
-	make -C doc install DESTDIR=$(DESTDIR)
+	$(MAKE) -C init install DESTDIR=$(DESTDIR)
+ifeq ($(builddoc),y)
+	$(MAKE) -C doc install DESTDIR=$(DESTDIR)
+else
+	@echo
+	@echo "WARNING: Documentation not built nor installed"
+endif
 	@echo
 	@echo "NOTICE: Modules installation is complete."
 	@echo "        Please read the 'Configuration' section in INSTALL.txt to learn"
@@ -255,13 +264,18 @@
 ifeq ($(compatversion),y)
 	rm -f $(addprefix $(DESTDIR)$(docdir)/,ChangeLog-compat NEWS-compat)
 endif
-endif
-	make -C init uninstall DESTDIR=$(DESTDIR)
-	make -C doc uninstall DESTDIR=$(DESTDIR)
+ifneq ($(builddoc),y)
+	rmdir $(DESTDIR)$(docdir)
+endif
+endif
+	$(MAKE) -C init uninstall DESTDIR=$(DESTDIR)
+ifeq ($(builddoc),y)
+	$(MAKE) -C doc uninstall DESTDIR=$(DESTDIR)
+endif
 	rmdir $(DESTDIR)$(libexecdir)
 	rmdir $(DESTDIR)$(bindir)
 	rmdir $(DESTDIR)$(datarootdir)
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(prefix)
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(prefix) || true
 
 # include pre-generated documents not to require documentation build
 # tools when installing from dist tarball
@@ -276,7 +290,7 @@
 		doc/build/module.1.in doc/build/modulefile.4 \
 		contrib/rpm/environment-modules.spec
 ifeq ($(compatversion) $(wildcard $(COMPAT_DIR)),y $(COMPAT_DIR))
-	make -C $(COMPAT_DIR) distdir
+	$(MAKE) -C $(COMPAT_DIR) distdir
 	mv $(COMPAT_DIR)/modules-* compatdist
 	tar -cf compatdist.tar --transform 's,^compatdist,$(DIST_PREFIX)/compat,' compatdist
 	tar --concatenate -f $(DIST_PREFIX).tar compatdist.tar
@@ -320,14 +334,16 @@
 	rm -f testsuite/example/.modulespath testsuite/example/modulerc
 	rm -f modules-*.tar modules-*.tar.gz modules-*.tar.bz2
 	rm -f modules-*.srpm
-	make -C init clean
-	make -C doc clean
+	$(MAKE) -C init clean
+ifeq ($(builddoc),y)
+	$(MAKE) -C doc clean
+endif
 ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
 	rm -f version.inc
 	rm -f contrib/rpm/environment-modules.spec
 endif
 ifneq ($(wildcard $(COMPAT_DIR)/Makefile),)
-	make -C compat clean
+	$(MAKE) -C compat clean
 endif
 
 distclean: clean
@@ -336,12 +352,14 @@
 	rm -rf $(NAGELFAR_RELEASE)
 ifeq ($(wildcard .git) $(wildcard $(COMPAT_DIR)),.git $(COMPAT_DIR))
 	rm -rf $(COMPAT_DIR)
+ifeq ($(gitworktree),y)
 	git worktree prune
+endif
 endif
 
 ifeq ($(compatversion) $(wildcard $(COMPAT_DIR)),y $(COMPAT_DIR))
 test: modulecmd.tcl $(COMPAT_DIR)/modulecmd
-	make -C $(COMPAT_DIR) test
+	$(MAKE) -C $(COMPAT_DIR) test
 else
 test: modulecmd.tcl
 endif
@@ -350,13 +368,3 @@
 	TESTSUITEDIR=`cd testsuite;pwd -P`; export TESTSUITEDIR; \
 	runtest --srcdir $$TESTSUITEDIR --objdir $$OBJDIR $(RUNTESTFLAGS) --tool modules
 
-testinstall:
-	OBJDIR=`pwd -P`; export OBJDIR; \
-	TESTSUITEDIR=`cd testsuite;pwd -P`; export TESTSUITEDIR; \
-	runtest --srcdir $$TESTSUITEDIR --objdir $$OBJDIR $(RUNTESTFLAGS) --tool install
-
-
-# install code coverage tool
-$(NAGELFAR):
-	wget http://downloads.sourceforge.net/nagelfar/$(NAGELFAR_RELEASE).tar.gz
-	tar xzf $(NAGELFAR_RELEASE).tar.gz

=== doc/Makefile ===
--- 
+++ 
@@ -16,6 +16,11 @@
 
 # source version definitions shared across the Makefiles of this project
 include ../version.inc
+
+# quit if no sphinx-build found at configure time
+ifneq ($(builddoc),y)
+  $(error No 'sphinx-build' command defined, cannot build documentation)
+endif
 
 man: $(BUILD_DIR)/module.1 $(BUILD_DIR)/modulefile.4
 ifeq ($(compatversion),y)
@@ -74,7 +79,7 @@
 
 # compatibility version-related rules
 $(COMPAT_MAN_DIR)/module.1 $(COMPAT_MAN_DIR)/modulefile.4:
-	make -C $(COMPAT_MAN_DIR) $(@F)
+	$(MAKE) -C $(COMPAT_MAN_DIR) $(@F)
 
 install: man txt
 	mkdir -p $(DESTDIR)$(mandir)/man1 $(DESTDIR)$(mandir)/man4

=== init/Makefile ===
--- 
+++ 
@@ -29,10 +29,10 @@
 endif
 
 # generate 'module use' commands to put in modulerc from modulepath
-modulerc := $(addprefix \nmodule use --append {,$(subst :,} {,$(modulepath)}))
+modulerc := $(addprefix \\\nmodule use --append {,$(subst :,} ,$(modulepath)}))
 # generate 'module load' commands to put in modulerc from loadedmodules
 ifneq ($(loadedmodules),)
-  modulerc := $(modulerc)$(addprefix \nmodule load ,\
+  modulerc := $(modulerc)$(addprefix \\\nmodule load ,\
     $(subst :, ,$(loadedmodules)))
 endif
 
@@ -66,6 +66,13 @@
 else
   compatversionre := /@compatversion@/d
   notcompatversionre := s|@notcompatversion@||g
+endif
+ifeq ($(usemanpath),y)
+  usemanpathre := s|@usemanpath@||g
+  notusemanpathre := /@notusemanpath@/d
+else
+  usemanpathre := /@usemanpath@/d
+  notusemanpathre := s|@notusemanpath@||g
 endif
 
 # comment entries if feature not enabled
@@ -106,13 +113,17 @@
 	-e '$(setbinpathre)' \
 	-e '$(compatversionre)' \
 	-e '$(notcompatversionre)' \
-	-e 's|@modulerc@|$(modulerc)|g' \
+	-e '$(usemanpathre)' \
+	-e '$(notusemanpathre)' \
+	-e $$'s|@modulerc@|$(modulerc)|g' \
 	-e 's|@modulepath@|$(modulepath)|g' \
 	-e '$(setquarvarsre)' $(quarvarsre) \
 	-e '$(notsetquarvarsre)' \
 	-e 's|@SHELLNAME@|$@|g' \
 	-e 's|@VERSIONING@|$(setversioning)|g' \
 	-e 's|@VERSION@|$(VERSION)|g' \
+	-e 's|@PS@|$(PS)|g' \
+	-e 's|@BASENAME@|$(BASENAME)|g' \
 	-e 's|@TCLSH@|$(TCLSH)|g' $< > $@
 endef
 
@@ -121,6 +132,13 @@
 
 %: %.in
 	$(translate-in-script)
+
+# workaround '\\\n' issue on Linux with Make 3.81
+modulerc: modulerc.in
+	$(translate-in-script)
+	mv $@ ${@}.tmp
+	sed -e 's|\\$$||' ${@}.tmp > $@
+	rm -f ${@}.tmp
 
 # tcsh is derivated from csh init script
 tcsh: csh.in
@@ -152,9 +170,9 @@
 uninstall-testconfig:
 	rmdir $(DESTDIR)$(prefix)/test/modulefiles $(DESTDIR)$(prefix)/test/etc $(DESTDIR)$(prefix)/test
 	rm -f $(addprefix $(DESTDIR)$(modulefilesdir)/,$(EXAMPLE_TESTCONFIG_MODFILES))
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(modulefilesdir)
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(etcdir)
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(initdir)
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(modulefilesdir) || true
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(etcdir) || true
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(initdir) || true
 
 install: all
 	mkdir -p $(DESTDIR)$(initdir)
@@ -169,7 +187,8 @@
 else
 	rm -f $(DESTDIR)$(initdir)/ksh-functions/switchml
 endif
-	cp -P --remove-destination $(ALL_CONFIG) $(DESTDIR)$(initdir)/
+	rm -f $(addprefix $(DESTDIR)$(initdir)/,$(ALL_CONFIG))
+	cp -R -P $(ALL_CONFIG) $(DESTDIR)$(initdir)/
 ifeq ($(examplemodulefiles),y)
 	cp $(addprefix $(EXAMPLE_MODFILES_SRCDIR)/,$(EXAMPLE_MODFILES)) $(DESTDIR)$(modulefilesdir)/
 endif
@@ -186,16 +205,16 @@
 endif
 	rm -f $(DESTDIR)$(initdir)/zsh-functions/_module
 	rm -f $(addprefix $(DESTDIR)$(initdir)/,$(ALL_CONFIG))
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(modulefilesdir)
-	@if [ -d $(DESTDIR)$(modulefilesdir) ]; then echo -e "\nWARNING: $(DESTDIR)$(modulefilesdir) is not empty so skip removal\n" >&2; fi
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(modulefilesdir) || true
+	@if [ -d $(DESTDIR)$(modulefilesdir) ]; then echo; echo "WARNING: $(DESTDIR)$(modulefilesdir) is not empty so skip removal" >&2; echo; fi
 	rmdir $(DESTDIR)$(initdir)/ksh-functions
 	rmdir $(DESTDIR)$(initdir)/zsh-functions
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(initdir)
-	@if [ -d $(DESTDIR)$(initdir) ]; then echo -e "\nWARNING: $(DESTDIR)$(initdir) is not empty so skip removal\n" >&2; fi
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(initdir) || true
+	@if [ -d $(DESTDIR)$(initdir) ]; then echo; echo "WARNING: $(DESTDIR)$(initdir) is not empty so skip removal" >&2; echo; fi
 ifeq ($(versioning),y)
 	rm -f $(DESTDIR)$(versdir)/$(VERSION)
-	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(versdir)
-	@if [ -d $(DESTDIR)$(versdir) ]; then echo -e "\nWARNING: $(DESTDIR)$(versdir) is not empty so skip removal\n" >&2; fi
+	$(RMDIR_IGN_NON_EMPTY) $(DESTDIR)$(versdir) || true
+	@if [ -d $(DESTDIR)$(versdir) ]; then echo; echo "WARNING: $(DESTDIR)$(versdir) is not empty so skip removal" >&2; echo; fi
 endif
 
 clean:

=== debian/changelog ===
modules (4.1.1-1) unstable; urgency=medium

  * New upstream release
  * Set VCS to point to salsa.debian.org
  * Ack. and close old bug on bash completion: Closes: #865118
  * Delete obsolete patches:
    - compiler_fixes.patch
    - debian/patches/fix_paths.patch
    - debian/patches/format.patch
  * Update  testsuite-fix.patch
  * Set mandir, etcdir in ./rules to configure site.exp correctly
  * set initdir. Closes: #890781
  * Add procps as a build-dep / runtime dependency

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 19 Feb 2018 16:47:47 +0000

=== debian/control ===
--- 
+++ 
@@ -4,15 +4,19 @@
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Standards-Version: 4.1.3
 Homepage: http://modules.sourceforge.net/
+Vcs-Browser: https://salsa.debian.org:/mckinstry/modules.git
+Vcs-Git: https://salsa.debian.org:/mckinstry/modules.git
 Build-Depends: tcl8.6-dev | tcl-dev, 
   debhelper (>= 10), 
   dejagnu, 
   tclx8.4-dev,
-  less
+  less,
+  procps
 
 Package: environment-modules
 Architecture: any
-Depends: debhelper (>= 10), tcl8.6 | tcl, ${misc:Depends}, ${shlibs:Depends}
+Depends: tcl8.6 | tcl, ${misc:Depends}, ${shlibs:Depends},
+ less, procps
 Conflicts: lmod
 Description: Modular system for handling environment variables
  The Modules package provides for the dynamic modification of a user's

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

TDIR=debian/environment-modules
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

DEB_BUILD_MAINT_OPTIONS:=hardening=+all
DEB_CFLAGS_MAINT_APPEND:= -Wall -pedantic
DEB_LDFLAGS_MAINT_APPEND:= -Wl,--as-needed
export  DEB_BUILD_MAINT_OPTIONS DEB_CFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_APPEND

# The magic debhelper  rule
%:
	dh $@ 

override_dh_auto_clean:
	$(MAKE) clean || echo "Make clean skipped"
	rm -f stamp-h

override_dh_auto_configure:
	dh_auto_configure -- \
                --prefix=/usr/share/modules \
		--libexecdir=$(LIBDIR) \
		--mandir=/usr/share/man \
		--etcdir=/etc/environment-modules \
		--initdir=/usr/share/modules/init \
		--with-version-path=/usr/share/modules/versions \
		--with-module-path=/usr/share/modules/modulefiles \
		--with-tcl-ver=8.6 \
		--enable-logging \
		--bindir=/usr/bin #LDFLAGS='$(LDFLAGS) -Wl,--as-needed' CFLAGS='$(CFLAGS) '

override_dh_auto_test:
	-dh_auto_test || echo "Ignoring known test failures in autoinit regexps"

override_dh_auto_install:
	dh_auto_install
	mv $(TDIR)/usr/share/modules/share/doc/* $(TDIR)/usr/share/doc/environment-modules
	rm -rf $(TDIR)/usr/share/modules/share
	rm $(TDIR)/usr/share/doc/environment-modules/COPYING.GPLv2* $(TDIR)/usr/share/doc/environment-modules/INSTALL.txt*
	rm $(TDIR)/usr/share/doc/environment-modules/ChangeLog
	cp debian/profile.sh $(TDIR)/etc/profile.d/modules.sh
	cp debian/modulespath site.exp $(TDIR)/etc/environment-modules
	dh_link /etc/environment-modules/modulespath /usr/share/modules/init/.modulespath 
	dh_link $(LIBDIR)/modulecmd.tcl /usr/lib/modulecmd.tcl
	dh_link /usr/share/modules/init/csh		/etc/csh/login.d/modules
	dh_link /usr/share/modules/init/bash_completion /usr/share/bash-completion/completions/modules

## modules 4.1.2

=== debian/changelog ===
modules (4.1.2-2) unstable; urgency=medium

  * Fix from Christophe Garion for zsh handling. Closes: #897686
  * Standards-Version: 4.1.4; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 08 May 2018 10:25:30 +0100

modules (4.1.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 04 Apr 2018 07:15:54 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Homepage: http://modules.sourceforge.net/
 Vcs-Browser: https://salsa.debian.org:/mckinstry/modules.git
 Vcs-Git: https://salsa.debian.org:/mckinstry/modules.git

## modules 4.1.3

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,15 @@
-.PHONY: doc pkgdoc initdir install install-testsiteconfig install-testmodulerc \
-	install-testetcrc install-testmodspath install-testmodspath-empty \
-	uninstall-testconfig uninstall dist dist-tar dist-gzip dist-bzip2 srpm \
-	clean distclean test testinstall instrument testcoverage
+.PHONY: doc pkgdoc initdir install install-testsiteconfig \
+	install-testsiteconfig-1 install-testmodulerc install-testetcrc \
+	install-testmodspath install-testmodspath-empty uninstall-testconfig \
+	uninstall dist dist-tar dist-gzip dist-bzip2 srpm clean distclean test \
+	testinstall instrument testcoverage
 
 # definitions for code coverage
+NAGELFAR_DLSRC1 := http://downloads.sourceforge.net/nagelfar/
+NAGELFAR_DLSRC2 := https://ftp.openbsd.org/pub/OpenBSD/distfiles/
 NAGELFAR_RELEASE := nagelfar125
+NAGELFAR_DIST := $(NAGELFAR_RELEASE).tar.gz
+NAGELFAR_DISTSUM := 707e3c305437dce1f14103f0bd058fc9
 NAGELFAR := $(NAGELFAR_RELEASE)/nagelfar.tcl
 COVERAGE_SRCFILE := modulecmd.tcl
 COVERAGE_IFILE := $(COVERAGE_SRCFILE:.tcl=.tcl_i)
@@ -23,7 +28,7 @@
 all: initdir modulecmd.tcl ChangeLog README \
 	contrib/scripts/add.modules contrib/scripts/modulecmd
 ifeq ($(compatversion),y)
-all: $(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog
+all: $(COMPAT_DIR)/modulecmd$(EXEEXT) $(COMPAT_DIR)/ChangeLog
 else
 endif
 # skip doc build if no sphinx-build
@@ -167,7 +172,7 @@
 	$(translate-in-script)
 
 # compatibility version-related rules
-$(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog:
+$(COMPAT_DIR)/modulecmd$(EXEEXT) $(COMPAT_DIR)/ChangeLog:
 	$(MAKE) -C $(COMPAT_DIR) $(@F)
 
 # example configs for test rules
@@ -180,6 +185,10 @@
 install-testsiteconfig: testsuite/example/siteconfig.tcl
 	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(etcdir)/
+
+install-testsiteconfig-1: testsuite/example/siteconfig.tcl-1
+	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
+	cp $^ $(DESTDIR)$(etcdir)/siteconfig.tcl
 
 install-testmodulerc: testsuite/example/modulerc
 	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
@@ -206,7 +215,7 @@
 
 ifeq ($(compatversion),y)
 install: modulecmd.tcl ChangeLog README contrib/scripts/add.modules \
-	contrib/scripts/modulecmd $(COMPAT_DIR)/modulecmd $(COMPAT_DIR)/ChangeLog
+	contrib/scripts/modulecmd $(COMPAT_DIR)/modulecmd$(EXEEXT) $(COMPAT_DIR)/ChangeLog
 else
 install: modulecmd.tcl ChangeLog README contrib/scripts/add.modules \
 	contrib/scripts/modulecmd
@@ -216,8 +225,8 @@
 	cp modulecmd.tcl $(DESTDIR)$(libexecdir)/
 	chmod +x $(DESTDIR)$(libexecdir)/modulecmd.tcl
 ifeq ($(compatversion),y)
-	cp $(COMPAT_DIR)/modulecmd $(DESTDIR)$(libexecdir)/modulecmd-compat
-	chmod +x $(DESTDIR)$(libexecdir)/modulecmd-compat
+	cp $(COMPAT_DIR)/modulecmd$(EXEEXT) $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
+	chmod +x $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
 endif
 	cp contrib/envml $(DESTDIR)$(bindir)/
 	chmod +x $(DESTDIR)$(bindir)/envml
@@ -253,7 +262,7 @@
 uninstall:
 	rm -f $(DESTDIR)$(libexecdir)/modulecmd.tcl
 ifeq ($(compatversion),y)
-	rm -f $(DESTDIR)$(libexecdir)/modulecmd-compat
+	rm -f $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
 endif
 	rm -f $(DESTDIR)$(bindir)/envml
 	rm -f $(DESTDIR)$(bindir)/add.modules
@@ -350,21 +359,3 @@
 	rm -f Makefile.inc
 	rm -f site.exp
 	rm -rf $(NAGELFAR_RELEASE)
-ifeq ($(wildcard .git) $(wildcard $(COMPAT_DIR)),.git $(COMPAT_DIR))
-	rm -rf $(COMPAT_DIR)
-ifeq ($(gitworktree),y)
-	git worktree prune
-endif
-endif
-
-ifeq ($(compatversion) $(wildcard $(COMPAT_DIR)),y $(COMPAT_DIR))
-test: modulecmd.tcl $(COMPAT_DIR)/modulecmd
-	$(MAKE) -C $(COMPAT_DIR) test
-else
-test: modulecmd.tcl
-endif
-	TCLSH=$(TCLSH); export TCLSH; \
-	OBJDIR=`pwd -P`; export OBJDIR; \
-	TESTSUITEDIR=`cd testsuite;pwd -P`; export TESTSUITEDIR; \
-	runtest --srcdir $$TESTSUITEDIR --objdir $$OBJDIR $(RUNTESTFLAGS) --tool modules
-

=== debian/changelog ===
modules (4.1.3-1) unstable; urgency=medium

  * New upstream release
  * zsh-modulecmd.patch merged upstream`

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 01 Jul 2018 20:17:12 +0100

## modules 4.2.0

=== debian/changelog ===
modules (4.2.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.2.1
  * Remove hard-coded xz compression for deb tarball

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 24 Oct 2018 11:31:00 +0100

modules (4.1.4-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.2.0

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 26 Aug 2018 07:49:11 +0100

## modules 4.2.1

=== debian/changelog ===
modules (4.2.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 13 Nov 2018 06:57:03 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Homepage: http://modules.sourceforge.net/
 Vcs-Browser: https://salsa.debian.org:/mckinstry/modules.git
 Vcs-Git: https://salsa.debian.org:/mckinstry/modules.git
